BP_UNFLATTEN_SEQ(1)

NAME
unflatten_seq - unflatten a genbank or genbank-style feature file into a nested SeqFeature hierarchy

SYNOPSIS
  unflatten_seq.PLS -e 3 -gff ~/cvs/bioperl-live/t/data/AE003644_Adh-genomic.gb

  unflatten_seq.PLS --detail ~/cvs/bioperl-live/t/data/AE003644_Adh-genomic.gb

  unflatten_seq.PLS -i foo.embl --from embl --to chadoxml -o out.chado.xml

  unflatten_seq.PLS --notypemap --detail --to asciitree -ethresh 2 AE003644_Adh-genomic.gb

DESCRIPTION
This script will unflatten a genbank or genbank-style file of SeqFeatures into a nested hierarchy.

See Bio::SeqFeature::Tools::Unflattener

In a GenBank/EMBL representation, features are 'flat' - for example, there is no link between an mRNA and a CDS, other than implicit links (eg via tags or via splice site coordinates) which may be hard to code for.

This is most easily illustrated with the default output format, asciitree

An unflattened genbank feature set may look like this (AB077698)

  Seq: AB077698
    databank_entry                                   1..2701[+]
    gene
      mRNA
        CDS hCHCR-G                                  80..1144[+]
        exon                                         80..1144[+]
      five_prime_UTR                                 1..79[+]
      located_sequence_feature                       137..196[+]
      located_sequence_feature                       239..292[+]
      located_sequence_feature                       617..676[+]
      located_sequence_feature                       725..778[+]
      three_prime_UTR                                1145..2659[+]
      polyA_site                                     1606..1606[+]
      polyA_site                                     2660..2660[+]

Or like this (portion of AE003734)

  gene
    mRNA CG3320-RA
      CDS CG3320-PA                                53126..54971[-]
      exon                                         52204..53323[-]
      exon                                         53404..53631[-]
      exon                                         53688..53735[-]
      exon                                         53798..53918[-]
      exon                                         54949..55287[-]
    mRNA CG3320-RB
      CDS CG3320-PB                                53383..54971[-]
      exon                                         52204..53631[-]
      exon                                         53688..53735[-]
      exon                                         53798..53918[-]
      exon                                         54949..55287[-]

The unflattening will also 'normalize' the containment hierarchy (in the sense of standardising it - e.g. making sure there is always a transcript record, even if genbank just specifies CDS and gene)

By default, the GenBank types will be mapped to SO types

See Bio::SeqFeature::Tools::TypeMapper

COMMAND LINE ARGUMENTS

-i|input FILE
    input file (can also be specified as last argument)

-from FORMAT
    input format (defaults to genbank)

    probably doesnt make so much sense to use this for non-flat formats; ie other than embl/genbank

-to FORMAT
    output format (defaults to asciitree)

    should really be a format that is nested SeqFeature aware; I think this is only asciitree, chadoxml and gff3

-gff
    with export to GFF3 format (pre-3 GFFs make no sense with unflattened sequences, as they have no set way of representing feature graphs)

-o|output FILE
    outfile defaults to STDOUT

-detail
    show extra detail on features (asciitree mode only)

-e|ethresh INT
    sets the error threshold on unflattening

    by default this script will throw a wobbly if it encounters weird stuff in the genbank file - raise the error threshold to signal these to be ignored (and reported on STDERR)

-nomagic
    suppress use_magic in unflattening (see Bio::SeqFeature::Tools::Unflattener

-notypemap
    suppress type mapping (see Bio::SeqFeature::Tools::TypeMapper

TODO
Bio::SeqFeature::Tools::Unflattener allows fine-grained control over the unflattening process - need to add more options to allow this control at the command line

FEEDBACK

  Mailing Lists
User feedback is an integral part of the evolution of this and other Bioperl modules. Send your comments and suggestions preferably to the Bioperl mailing list. Your participation is much appreciated.

  bioperl-l@bioperl.org              - General discussion
  http://bioperl.org/MailList.shtml  - About the mailing lists

  Reporting Bugs
Report bugs to the Bioperl bug tracking system to help us keep track of the bugs and their resolution. Bug reports can be submitted via email or the web:

 http://bugzilla.bioperl.org/

AUTHOR
 Chris Mungall E<lt>cjm-at-bioperl.orgE<gt>